## iniparser 4.1

=== test/Makefile ===
CC   ?= gcc

ifndef V
QUIET_CC         = @echo "CC	$@";
QUIET_MAKE_TESTS = @echo "GN	Alltests.c";
endif

DEPS = $(shell ls ../src/*.[ch])

SRC = $(shell ls *.c | sed 's/AllTests.c//')
OBJ = $(SRC:.c=.o)

INCLUDE = -I../src
CFLAGS  += -pipe -ansi -pedantic -Wall -Wextra -g
LDFLAGS +=

all: check

check: testrun
	@./testrun

testrun: AllTests.o $(OBJ)
	$(QUIET_CC)$(CC) -o $@ AllTests.o $(OBJ) $(LDFLAGS)

AllTests.o: $(OBJ)
	$(QUIET_MAKE_TESTS)./make-tests.sh > AllTests.c
	$(QUIET_CC)$(CC) -c -o AllTests.o AllTests.c $(CFLAGS) $(INCLUDE)

%.o: %.c $(DEPS)
	$(QUIET_CC)$(CC) -c -o $@ $< $(CFLAGS) $(INCLUDE)

clean veryclean:
	rm -rf AllTests.c
	rm -rf $(OBJ) AllTests.o
	rm -rf testrun

=== debian/changelog ===
iniparser (4.1-4) unstable; urgency=medium

  * Add an initial Gitlab CI config file
  * debian/.gitlab-ci.yml: Update image used for Gitlab CI
  * Update .gitlab-ci.yml based on Salsa CI Team's template
  * GitLab CI/Lintian: install dpkg-dev, that ships dpkg-architecture, needed
    to run some Lintian checks
  * Replace home-made GitLab CI with the standard Salsa pipeline
  * Bump Debhelper compat level to 12
  * Declare compliance with Debian policy 4.3.0
  * Add Build-Depends-Package to debian/libiniparser1.symbols

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 28 Dec 2018 17:38:41 +0100

iniparser (4.1-3) unstable; urgency=medium

  * Update copyright years for debian/* packaging files
  * Bump Debhelper compat level to 11
  * Drop Build-Depends on autotools-dev
  * Declare compliance with Debian policy 4.1.3
  * Update Vcs-* fields for switch to salsa.debian.org

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 19 Mar 2018 10:52:52 +0100

iniparser (4.1-2) unstable; urgency=medium

  * Set Multi-Arch: foreign for libiniparser-doc documentation package
  * Declare compliance with Debian policy 4.1.2
  * Set Rules-Requires-Root to no

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 03 Dec 2017 09:39:21 +0100

iniparser (4.1-1) unstable; urgency=medium

  * New upstream version 4.1
  * Update symbols for 4.1

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 02 Nov 2017 12:36:45 +0100

iniparser (4.0-1) unstable; urgency=low

  * Initial release. (Closes: #738850)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 17 Oct 2017 22:05:58 +0200

=== debian/control ===
Source: iniparser
Section: libs
Priority: optional
Maintainer: Salvatore Bonaccorso <carnil@debian.org>
Build-Depends: debhelper-compat (= 12), cmake, doxygen
Standards-Version: 4.3.0
Homepage: http://ndevilla.free.fr/iniparser/
Vcs-Browser: https://salsa.debian.org/carnil/iniparser
Vcs-Git: https://salsa.debian.org/carnil/iniparser.git
Rules-Requires-Root: no

Package: libiniparser-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libiniparser1 (= ${binary:Version}), ${misc:Depends}
Recommends: libiniparser-doc (= ${binary:Version})
Description: development files for the iniParser INI file reader/writer
 This package contains development libraries and headers for the iniParser
 INI file reader/writer.
 .
 The iniParser library is a simple C library offering INI file parsing
 services (both reading and writing).

Package: libiniparser-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: documentation files for the iniParser INI file reader/writer
 This package contains HTML documentation for the iniParser INI file
 reader/writer.
 .
 The iniParser library is a simple C library offering INI file parsing
 services (both reading and writing).

Package: libiniparser1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: runtime library for the iniParser INI file reader/writer
 This package contains the runtime library for the iniParser INI file
 reader/writer.
 .
 The iniParser library is a simple C library offering INI file parsing
 services (both reading and writing).

=== debian/tests/control ===
Tests: iniexample
Depends: @, build-essential
Restrictions: allow-stderr

Tests: parse
Depends: @, build-essential

=== debian/watch ===
version=4
https://github.com/ndevilla/@PACKAGE@/releases /ndevilla/@PACKAGE@/archive/v@ANY_VERSION@@ARCHIVE_EXT@

## iniparser 4.2.1

=== example/Makefile ===
#
# iniparser tests Makefile
#

CC      ?= gcc
CFLAGS  += -g -I../src
LFLAGS  += -L.. -liniparser
AR	    ?= ar
ARFLAGS += rcv
RM      ?= rm -f


default: all

all: iniexample iniwrite parse

iniexample: iniexample.c
	$(CC) $(CFLAGS) -o iniexample iniexample.c -I../src -L.. -liniparser

iniwrite: iniwrite.c
	$(CC) $(CFLAGS) -o iniwrite iniwrite.c -I../src -L.. -liniparser

parse: parse.c
	$(CC) $(CFLAGS) -o parse parse.c -I../src -L.. -liniparser

clean veryclean:
	$(RM) iniexample example.ini parse

=== test/Makefile ===
--- 
+++ 
@@ -33,3 +33,4 @@
 	rm -rf AllTests.c
 	rm -rf $(OBJ) AllTests.o
 	rm -rf testrun
+	rm -rf ./ressources/new.ini ./ressources/test.ini ./ressources/test.txt

=== debian/changelog ===
iniparser (4.2.1-1ubuntu0.1) oracular-security; urgency=medium

  * SECURITY UPDATE: heap overflow in iniparser_dumpsection_ini()
    - debian/patches/CVE-2025-0633-1.patch: return if name doesn't fit in
      buffer in src/iniparser.c.
    - debian/patches/CVE-2025-0633-2.patch: add test to
      test/test_iniparser.c.
    - CVE-2025-0633

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 21 Feb 2025 12:44:47 -0500

iniparser (4.2.1-1) unstable; urgency=medium

  * New upstream version 4.2.1
  * debian/control: Homepage: Reflect upstream move to gitlab
  * debian/copyright: Source: Reflect upstream move to gitlab
  * debian/u/metadata: Reflect upstream move to gitlab
  * debian/watch: Move watch URL to gitlab.com hosting releases
  * Mark cmake support patach as forwarded upstream

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 17 May 2024 11:31:27 +0200

iniparser (4.2-1) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 11 May 2024 21:03:35 +0200

iniparser (4.2-1~exp1) experimental; urgency=medium

  * New upstream version 4.2
  * Update copyright years for upstream files
  * Declare compliance with Debian policy 4.7.0
  * Update copyright years for debian/* packaging files
  * libiniparser1: Update symbols for 4.2
  * debian/tests: Add another autopkgtest to write ini file
  * debian/control: Point homepage field to github repository

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 11 May 2024 09:51:01 +0200

iniparser (4.1-7) unstable; urgency=medium

  * Handle null return from iniparser_getstring (CVE-2023-33461)
  * Declare compliance with Debian policy 4.6.2
  * Update copyright years for debian/* packaging files

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 16 Sep 2023 16:01:05 +0200

iniparser (4.1-6) unstable; urgency=medium

  * debian/watch: Watch for tagged releases on github

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 16 Dec 2021 09:43:45 +0100

iniparser (4.1-5) unstable; urgency=medium

  [ Salvatore Bonaccorso ]
  * Rename and update salsa-ci.yml based on Salsa CI Team's template
  * Bump Debhelper compat level to 13
  * Declare compliance with Debian policy 4.6.0
  * Fix buffer overflow from sprintf (Closes: #985097)
  * Fail testrun on test failure (Closes: #985099)
  * Update copyright years for debian/* packaging files
  * Updated test for when long int is not 8 byte
  * Don't send a const ptr to asprintf()
  * test/testiniparser.c: fix missing comma in token test list

  [ Debian Janitor ]
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.
  * Set upstream metadata fields: Bug-Submit, Repository.
  * Update pattern for GitHub archive URLs from /<org>/<repo>/tags
    page/<org>/<repo>/archive/<tag> -> /<org>/<repo>/archive/refs/tags/<tag>.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 05 Dec 2021 10:06:09 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: iniparser
 Section: libs
 Priority: optional
-Maintainer: Salvatore Bonaccorso <carnil@debian.org>
-Build-Depends: debhelper-compat (= 12), cmake, doxygen
-Standards-Version: 4.3.0
-Homepage: http://ndevilla.free.fr/iniparser/
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Salvatore Bonaccorso <carnil@debian.org>
+Build-Depends: debhelper-compat (= 13), cmake, doxygen
+Standards-Version: 4.7.0
+Homepage: https://gitlab.com/iniparser/iniparser
 Vcs-Browser: https://salsa.debian.org/carnil/iniparser
 Vcs-Git: https://salsa.debian.org/carnil/iniparser.git
 Rules-Requires-Root: no

=== debian/tests/control ===
--- 
+++ 
@@ -4,3 +4,6 @@
 
 Tests: parse
 Depends: @, build-essential
+
+Tests: iniwrite
+Depends: @, build-essential

## iniparser 4.2.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

project(iniparser VERSION 4.2.4)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(CMakeDependentOption)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

option(
  BUILD_SHARED_LIBS
  "Build using shared libraries"
  ON)
# For packaging by tools like bitbake, shared and static libs should be build
# at once
CMAKE_DEPENDENT_OPTION(BUILD_STATIC_LIBS "Build static libs" ON
                      "BUILD_SHARED_LIBS" OFF)
if(BUILD_SHARED_LIBS)
  list(
    APPEND
    TARGET_TYPES
    "shared")
endif()
if(BUILD_STATIC_LIBS OR NOT BUILD_SHARED_LIBS)
  list(
    APPEND
    TARGET_TYPES
    "static")
endif()
set(CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")

foreach(TARGET_TYPE ${TARGET_TYPES})
  set(TARGET_NAME "${PROJECT_NAME}-${TARGET_TYPE}")
  set(TARGETS_EXPORT_NAME "${TARGET_NAME}Targets")
  string(TOUPPER ${TARGET_TYPE} UPPER_TARGET_TYPE)
  message(DEBUG "TARGET_TYPE: ${TARGET_TYPE}")
  message(DEBUG "UPPER_TARGET_TYPE: ${UPPER_TARGET_TYPE}")
  message(DEBUG "TARGET_NAME: ${TARGET_NAME}")
  add_library(
    ${TARGET_NAME}
    ${UPPER_TARGET_TYPE}
    "src/iniparser.c"
    "src/dictionary.c")
  set(PUBLIC_HEADERS "src/iniparser.h" "src/dictionary.h")
  set_target_properties(${TARGET_NAME} PROPERTIES PUBLIC_HEADER
                                                  "${PUBLIC_HEADERS}")

  target_include_directories(
    ${TARGET_NAME}
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
           $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}>)
  set_target_properties(${TARGET_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
  set_target_properties(${TARGET_NAME} PROPERTIES VERSION ${PROJECT_VERSION})
  set_target_properties(${TARGET_NAME} PROPERTIES SOVERSION
                                                  ${PROJECT_VERSION_MAJOR})

  if(UNIX)
    target_compile_options(
      ${TARGET_NAME}
      PRIVATE -fPIC
              -Wall
              -Wextra
              -pedantic)
  endif(UNIX)

  # install targets
  install(
    TARGETS ${TARGET_NAME}
    EXPORT ${TARGETS_EXPORT_NAME}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})

  # build directory package config
  export(
    TARGETS ${TARGET_NAME}
    APPEND
    FILE "${TARGETS_EXPORT_NAME}.cmake")

  # installed package config
  install(EXPORT ${TARGETS_EXPORT_NAME} DESTINATION "${CONFIG_INSTALL_DIR}")
endforeach()

# installed package config
set(PROJECT_CONFIG_FILE
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake")
set(PROJECT_VERSION_FILE
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake")

configure_package_config_file(
  ${PROJECT_SOURCE_DIR}/cmake/config.cmake.in ${PROJECT_CONFIG_FILE}
  INSTALL_DESTINATION "${CONFIG_INSTALL_DIR}")
# generate package version file
write_basic_package_version_file(
  ${PROJECT_VERSION_FILE}
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMajorVersion)
# install version and config file
install(FILES ${PROJECT_VERSION_FILE} ${PROJECT_CONFIG_FILE}
        DESTINATION ${CONFIG_INSTALL_DIR})
file(
  GLOB
  FIND_MODULES
  "${PROJECT_SOURCE_DIR}/cmake/Find*.cmake")
message(DEBUG "Find modules: ${FIND_MODULES}")
install(FILES ${FIND_MODULES} DESTINATION ${CONFIG_INSTALL_DIR})
# make available in build directory for user package registry dependants
file(COPY ${FIND_MODULES} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
# add to CMake registry
export(PACKAGE ${PROJECT_NAME})
# generate pc-file
include(JoinPaths)
join_paths(libdir_for_pc_file "\${exec_prefix}" "${CMAKE_INSTALL_LIBDIR}")
join_paths(includedir_for_pc_file "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}" "${PROJECT_NAME}")
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc
  @ONLY)
# install pc-file
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

if(BUILD_TESTING)
  enable_testing()
  add_subdirectory(test)
endif()

option(BUILD_EXAMPLES "Build and install examples")
if(BUILD_EXAMPLES)
  add_executable(iniexample ${CMAKE_CURRENT_SOURCE_DIR}/example/iniexample.c)
  add_executable(iniwrite ${CMAKE_CURRENT_SOURCE_DIR}/example/iniwrite.c)
  add_executable(parse ${CMAKE_CURRENT_SOURCE_DIR}/example/parse.c)

  foreach(TARGET_TYPE ${TARGET_TYPES})
    # if BUILD_STATIC_LIBS=ON shared takes precedence
    target_link_libraries(iniexample ${PROJECT_NAME}-${TARGET_TYPE})
    target_link_libraries(iniwrite ${PROJECT_NAME}-${TARGET_TYPE})
    target_link_libraries(parse ${PROJECT_NAME}-${TARGET_TYPE})
  endforeach()
  install(
    TARGETS iniexample
            iniwrite
            parse
    DESTINATION ${CMAKE_INSTALL_DOCDIR}/examples/)
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/example/twisted.ini
          DESTINATION ${CMAKE_INSTALL_DOCDIR}/examples/)
endif()

option(
  BUILD_DOCS
  "Build and install docs"
  ON)
if(BUILD_DOCS)
  find_package(Doxygen REQUIRED)
  set(DOXYGEN_STRIP_FROM_PATH ${CMAKE_CURRENT_SOURCE_DIR})
  doxygen_add_docs(
    docs
    ${CMAKE_CURRENT_SOURCE_DIR}/doc/iniparser.txt
    ${CMAKE_CURRENT_SOURCE_DIR}/src/iniparser.h
    ALL
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
          DESTINATION ${CMAKE_INSTALL_DOCDIR})
endif()

=== test/CMakeLists.txt ===
include(FetchContent)
include(CTest)

find_program(
  RUBY_EXECUTABLE
  NAME
  ruby
  PATHS ENV
        PATH
        REQUIRED)

if(MSVC)
  message(STATUS "MSVC environment")
  find_file(
    MSVC_DIRENT
    "dirent.h"
    REQUIRED)
  message(STATUS "MSVC_DIRENT: ${MSVC_DIRENT}")
  get_filename_component(
    MSVC_DIRENT_INCLUDE_DIR
    ${MSVC_DIRENT}
    DIRECTORY)
  message(STATUS "MSVC_DIRENT_INCLUDE_DIR: ${MSVC_DIRENT_INCLUDE_DIR}")
  include_directories(${MSVC_DIRENT_INCLUDE_DIR})
endif()

set(FETCHCONTENT_QUIET OFF)

FetchContent_Declare(
  unity
  GIT_REPOSITORY "https://github.com/throwtheswitch/unity.git"
  GIT_PROGRESS TRUE
  PATCH_COMMAND ${CMAKE_COMMAND} -E copy
                ${CMAKE_CURRENT_LIST_DIR}/unity_config.h ./src/)

FetchContent_MakeAvailable(unity)
target_compile_definitions(unity PUBLIC UNITY_INCLUDE_CONFIG_H)

function(create_test_runner)
  set(options)
  set(oneValueArgs NAME)
  set(multiValueArgs)
  cmake_parse_arguments(
    TEST_RUNNER
    "${options}"
    "${oneValueArgs}"
    "${multiValueArgs}"
    ${ARGN})

  message(STATUS "Creating test_${TEST_RUNNER_NAME}")
  add_custom_command(
    OUTPUT test_${TEST_RUNNER_NAME}_runner.c
    COMMAND
      ${RUBY_EXECUTABLE} ${unity_SOURCE_DIR}/auto/generate_test_runner.rb
      ${CMAKE_CURRENT_SOURCE_DIR}/test_${TEST_RUNNER_NAME}.c
      test_${TEST_RUNNER_NAME}_runner.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/test_${TEST_RUNNER_NAME}.c
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    BYPRODUCTS test_${TEST_RUNNER_NAME}_runner.c)

  add_executable(test_${TEST_RUNNER_NAME} test_${TEST_RUNNER_NAME}.c
                                          test_${TEST_RUNNER_NAME}_runner.c)
  # Prevent MSVC from creating Debug or Release subdirectories for test
  # executables
  set_target_properties(
    test_${TEST_RUNNER_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY
                                        ${CMAKE_CURRENT_BINARY_DIR}/$<0:>)
  foreach(TARGET_TYPE ${TARGET_TYPES})
    # if BUILD_STATIC_LIBS=ON shared takes precedence
    target_link_libraries(
      test_${TEST_RUNNER_NAME}
      ${PROJECT_NAME}-${TARGET_TYPE}
      unity)
  endforeach()
endfunction()

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/ressources
     DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
create_test_runner(NAME ${PROJECT_NAME})
message(STATUS "Adding test test_${PROJECT_NAME}")
add_test(
  NAME test_${PROJECT_NAME}
  COMMAND test_${PROJECT_NAME}
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

create_test_runner(NAME dictionary)
message(STATUS "Adding test test_dictionary")
add_test(
  NAME test_dictionary
  COMMAND test_dictionary
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== debian/changelog ===
iniparser (4.2.4-1) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 26 Sep 2024 23:51:06 +0200

iniparser (4.2.4-1~exp1) experimental; urgency=medium

  * New upstream version 4.2.4
  * libiniparser-dev: Include installation of pkgconfig and cmake files
  * Rename runtime library binary package to libiniparser4 for upstream soname
    adjustment

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 21 Sep 2024 20:53:08 +0200

## iniparser 4.2.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,22 +1,30 @@
 cmake_minimum_required(VERSION 3.18)
 
-project(iniparser VERSION 4.2.4)
+project(
+  iniparser
+  DESCRIPTION "C library for parsing INI-style files"
+  HOMEPAGE_URL https://gitlab.com/iniparser/iniparser/
+  LANGUAGES C
+  VERSION 4.2.5)
 
 include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
 include(CMakeDependentOption)
 
-set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
-  "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 option(
   BUILD_SHARED_LIBS
   "Build using shared libraries"
   ON)
-# For packaging by tools like bitbake, shared and static libs should be build
-# at once
-CMAKE_DEPENDENT_OPTION(BUILD_STATIC_LIBS "Build static libs" ON
-                      "BUILD_SHARED_LIBS" OFF)
+# For packaging by tools like bitbake, shared and static libs should be build at
+# once
+cmake_dependent_option(
+  BUILD_STATIC_LIBS
+  "Build static libs"
+  ON
+  "BUILD_SHARED_LIBS"
+  OFF)
 if(BUILD_SHARED_LIBS)
   list(
     APPEND
@@ -46,12 +54,47 @@
   set(PUBLIC_HEADERS "src/iniparser.h" "src/dictionary.h")
   set_target_properties(${TARGET_NAME} PROPERTIES PUBLIC_HEADER
                                                   "${PUBLIC_HEADERS}")
-
   target_include_directories(
     ${TARGET_NAME}
     PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}>)
-  set_target_properties(${TARGET_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
+  # If both shared and static libs are build at once with MSVC it generates a
+  # shared library consisting of
+  #
+  # * a DLL (that contains the actual code) with filename suffix `.dll`,
+  # * a correspoding import library (against which users should link) with
+  #   filename suffix `.lib`.
+  #
+  # and a static library with filename suffix `.lib`
+  #
+  # As both, the shared import library and the static library share the same
+  # basename and suffix one would overwrite the other.
+  #
+  # To solve this issue we set the PREFIX for *static* libs explicitely so MSVC
+  # will build:
+  #
+  # * shared: iniparser.dll
+  # * import: iniparser.lib
+  # * static: libiniparser.lib
+  #
+  # As all other platforms already set `PREFIX` for all lib types they remain
+  # unchanged. Therefore no `if(MSVC)` check is needed here.
+  #
+  if(TARGET_TYPE
+     MATCHES
+     "static")
+    set_target_properties(${TARGET_NAME}
+                          PROPERTIES OUTPUT_NAME "${PROJECT_NAME}" PREFIX "lib")
+  else()
+    set_target_properties(${TARGET_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
+    # automatically create a module definition (.def) file for MSVC so it will
+    # build an import library (.lib)
+    set_property(TARGET ${TARGET_NAME} PROPERTY WINDOWS_EXPORT_ALL_SYMBOLS 1)
+    if(WIN32)
+      # Let MinGW as MSVC not prefix the DLL
+      set_property(TARGET ${TARGET_NAME} PROPERTY PREFIX "")
+    endif()
+  endif()
   set_target_properties(${TARGET_NAME} PROPERTIES VERSION ${PROJECT_VERSION})
   set_target_properties(${TARGET_NAME} PROPERTIES SOVERSION
                                                   ${PROJECT_VERSION_MAJOR})
@@ -71,6 +114,7 @@
     EXPORT ${TARGETS_EXPORT_NAME}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} # install DLLs on Windows
     PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})
 
   # build directory package config
@@ -112,8 +156,15 @@
 export(PACKAGE ${PROJECT_NAME})
 # generate pc-file
 include(JoinPaths)
-join_paths(libdir_for_pc_file "\${exec_prefix}" "${CMAKE_INSTALL_LIBDIR}")
-join_paths(includedir_for_pc_file "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}" "${PROJECT_NAME}")
+join_paths(
+  libdir_for_pc_file
+  "\${exec_prefix}"
+  "${CMAKE_INSTALL_LIBDIR}")
+join_paths(
+  includedir_for_pc_file
+  "\${prefix}"
+  "${CMAKE_INSTALL_INCLUDEDIR}"
+  "${PROJECT_NAME}")
 configure_file(
   ${CMAKE_CURRENT_SOURCE_DIR}/cmake/pc.in
   ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc
@@ -148,19 +199,16 @@
           DESTINATION ${CMAKE_INSTALL_DOCDIR}/examples/)
 endif()
 
-option(
-  BUILD_DOCS
-  "Build and install docs"
-  ON)
+option(BUILD_DOCS "Build and install docs")
 if(BUILD_DOCS)
   find_package(Doxygen REQUIRED)
   set(DOXYGEN_STRIP_FROM_PATH ${CMAKE_CURRENT_SOURCE_DIR})
+  set(DOXYGEN_USE_MDFILE_AS_MAINPAGE README.md)
   doxygen_add_docs(
     docs
-    ${CMAKE_CURRENT_SOURCE_DIR}/doc/iniparser.txt
+    ${CMAKE_CURRENT_SOURCE_DIR}/README.md
     ${CMAKE_CURRENT_SOURCE_DIR}/src/iniparser.h
-    ALL
-    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc)
+    ALL)
   install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
           DESTINATION ${CMAKE_INSTALL_DOCDIR})
 endif()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -55,16 +55,10 @@
       ${CMAKE_CURRENT_SOURCE_DIR}/test_${TEST_RUNNER_NAME}.c
       test_${TEST_RUNNER_NAME}_runner.c
     DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/test_${TEST_RUNNER_NAME}.c
-    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
-    BYPRODUCTS test_${TEST_RUNNER_NAME}_runner.c)
+    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
 
   add_executable(test_${TEST_RUNNER_NAME} test_${TEST_RUNNER_NAME}.c
                                           test_${TEST_RUNNER_NAME}_runner.c)
-  # Prevent MSVC from creating Debug or Release subdirectories for test
-  # executables
-  set_target_properties(
-    test_${TEST_RUNNER_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY
-                                        ${CMAKE_CURRENT_BINARY_DIR}/$<0:>)
   foreach(TARGET_TYPE ${TARGET_TYPES})
     # if BUILD_STATIC_LIBS=ON shared takes precedence
     target_link_libraries(
@@ -82,6 +76,12 @@
   NAME test_${PROJECT_NAME}
   COMMAND test_${PROJECT_NAME}
   WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
+add_custom_command(
+  TARGET test_${PROJECT_NAME}
+  POST_BUILD
+  COMMAND ${CMAKE_COMMAND} -E copy -t $<TARGET_FILE_DIR:test_${PROJECT_NAME}>
+          $<TARGET_RUNTIME_DLLS:test_${PROJECT_NAME}>
+  COMMAND_EXPAND_LISTS)
 
 create_test_runner(NAME dictionary)
 message(STATUS "Adding test test_dictionary")
@@ -89,3 +89,9 @@
   NAME test_dictionary
   COMMAND test_dictionary
   WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
+add_custom_command(
+  TARGET test_dictionary
+  POST_BUILD
+  COMMAND ${CMAKE_COMMAND} -E copy -t $<TARGET_FILE_DIR:test_dictionary>
+          $<TARGET_RUNTIME_DLLS:test_dictionary>
+  COMMAND_EXPAND_LISTS)

=== debian/changelog ===
iniparser (4.2.5-1) unstable; urgency=medium

  * New upstream version 4.2.5
  * debian/rules: configure: Enable documentation build
  * Update copyright years for debian/* packaging files
  * debian/tests: Add testcase from upstream issue #175
  * README: Fix privacy-breach-generic caused by included images

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 17 Jan 2025 13:54:23 +0100

## iniparser 4.2.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
   DESCRIPTION "C library for parsing INI-style files"
   HOMEPAGE_URL https://gitlab.com/iniparser/iniparser/
   LANGUAGES C
-  VERSION 4.2.5)
+  VERSION 4.2.6)
 
 include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
@@ -207,6 +207,8 @@
   doxygen_add_docs(
     docs
     ${CMAKE_CURRENT_SOURCE_DIR}/README.md
+    ${CMAKE_CURRENT_SOURCE_DIR}/FAQ-en.md
+    ${CMAKE_CURRENT_SOURCE_DIR}/FAQ-zhcn.md
     ${CMAKE_CURRENT_SOURCE_DIR}/src/iniparser.h
     ALL)
   install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,8 @@
                 ${CMAKE_CURRENT_LIST_DIR}/unity_config.h ./src/)
 
 FetchContent_MakeAvailable(unity)
-target_compile_definitions(unity PUBLIC UNITY_INCLUDE_CONFIG_H)
+target_compile_definitions(unity PUBLIC UNITY_INCLUDE_CONFIG_H
+                                        UNITY_USE_COMMAND_LINE_ARGS)
 
 function(create_test_runner)
   set(options)
@@ -53,7 +54,7 @@
     COMMAND
       ${RUBY_EXECUTABLE} ${unity_SOURCE_DIR}/auto/generate_test_runner.rb
       ${CMAKE_CURRENT_SOURCE_DIR}/test_${TEST_RUNNER_NAME}.c
-      test_${TEST_RUNNER_NAME}_runner.c
+      test_${TEST_RUNNER_NAME}_runner.c ${CMAKE_CURRENT_LIST_DIR}/unity-config.yml
     DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/test_${TEST_RUNNER_NAME}.c
     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== debian/changelog ===
iniparser (4.2.6-1) unstable; urgency=medium

  * New upstream version 4.2.6
  * Update "README: Fix privacy-breach-generic caused by included images"

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 18 Feb 2025 22:44:45 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: iniparser
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Salvatore Bonaccorso <carnil@debian.org>
+Maintainer: Salvatore Bonaccorso <carnil@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake, doxygen
 Standards-Version: 4.7.0
 Homepage: https://gitlab.com/iniparser/iniparser
@@ -14,7 +13,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libiniparser1 (= ${binary:Version}), ${misc:Depends}
+Depends: libiniparser4 (= ${binary:Version}), ${misc:Depends}
 Recommends: libiniparser-doc (= ${binary:Version})
 Description: development files for the iniParser INI file reader/writer
  This package contains development libraries and headers for the iniParser
@@ -35,7 +34,7 @@
  The iniParser library is a simple C library offering INI file parsing
  services (both reading and writing).
 
-Package: libiniparser1
+Package: libiniparser4
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_DOCS=ON

=== debian/tests/control ===
--- 
+++ 
@@ -7,3 +7,6 @@
 
 Tests: iniwrite
 Depends: @, build-essential
+
+Tests: upstream-issue-175
+Depends: @, build-essential

=== debian/watch ===
version=4
opts="searchmode=plain" \
 https://gitlab.com/@PACKAGE@/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
